#!/bin/sh

#
#
# Quick and dirty script to start cmplayer on LAN
#
# You MUST edit:
#
#	HOSTS	variable (list of hosts which will run cmplayer)
#	BCAST	broadcast address of $HOSTS
#	MASTER  the IP of master server (attached to same network as $HOSTS)
#	BASE	base path of cmplayer installation
#	BM		base path of movies
#	RSH		rsh/ssh command to use
#
# Requires:
#	killall (linux syntax)
#	rsh/ssh setup to allow remote commands w/o auth dialog
#

HOSTS="n-n01 n-n02 n-n03 n-n04 n-n05 n-n06"
N=`echo "$HOSTS" | wc -w | tr -d ' '`

BCAST=192.168.0.255
MASTER=`hostname`
BASE=/usr/local/cm/
#RSH="ssh -x1 -n"
RSH="rsh -n"



PG=cmplayer
UDP=-udp
#UDP=""
TCP="-srv $MASTER"
#TCP=""

if [ "_$2" = "_" ]
then
	echo Use: $0 "[start|stop] movie"
	exit 1
fi

#MOVIE=/mnt/disk/data/tn.mpg
MOVIE=$BM/$2

PATH=$PATH:/usr/local/bin:$BASE/bin
export PATH


case $1 in
	"start")
		
		serv-select -d -p 7687 -n $N -t 5 &

		for h in $HOSTS
		do
			$RSH $h \
			env \
			DISPLAY=:0.0 \
			'PATH=$PATH:/usr/local/bin' \
			LD_LIBRARY_PATH=/usr/local/lib \
			$BASE/bin/cmplayer \
			$UDP $TCP \
			-framedrop \
			-autosync 0 \
			-quiet \
			-nosound \
			-vm -vo x11 \
			$MOVIE \> $h.log 2\>\&1 &
			echo $h
		done
		echo waiting for $N answers
		if wait %1
		then
			echo starting players
			tcp-client -H $BCAST -p 7686 -b -a $N -s QUIT
			echo all clients started
		else
			echo ERROR: Some clients failed
			cmplayer.sh stop $MOVIE
		fi
		;;

	"stop")

		for h in $HOSTS
		do
			$RSH $h \
			killall -s TERM $PG
			echo $h
		done
		sleep 2
		;;

esac

